3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
15 unset COMMIT_AUTHOR_EMAIL
16 unset COMMIT_AUTHOR_NAME
17 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
19 unset GIT_AUTHOR_EMAIL
21 unset GIT_COMMITTER_EMAIL
22 unset GIT_COMMITTER_NAME
25 unset GIT_EXTERNAL_DIFF
27 unset GIT_OBJECT_DIRECTORY
28 unset SHA1_FILE_DIRECTORIES
29 unset SHA1_FILE_DIRECTORY
31 # Each test should start with something like this, after copyright notices:
33 # test_description='Description of this test...
34 # This test checks if command xyzzy does the right thing...
48 test "${test_description}" != "" ||
49 error "Test script did not set test_description."
54 -d|--d|--de|--deb|--debu|--debug)
56 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
58 -h|--h|--he|--hel|--help)
59 echo "$test_description"
61 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
69 if test "$verbose" = "t"
73 exec 4>/dev/null 3>/dev/null
79 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
82 # You are not expected to call test_ok_ and test_failure_ directly, use
83 # the text_expect_* functions instead.
86 test_count=$(expr "$test_count" + 1)
87 say " ok $test_count: $@"
91 test_count=$(expr "$test_count" + 1)
92 test_failure=$(expr "$test_failure" + 1);
93 say "FAIL $test_count: $1"
95 echo "$@" | sed -e 's/^/ /'
96 test "$immediate" = "" || { trap - exit; exit 1; }
101 test "$debug" = "" || eval "$1"
110 test_expect_failure () {
112 error "bug in the test script: not 2 parameters to test-expect-failure"
113 say >&3 "expecting failure: $2"
115 if [ "$?" = 0 -a "$eval_ret" != 0 ]
123 test_expect_success () {
125 error "bug in the test script: not 2 parameters to test-expect-success"
126 say >&3 "expecting success: $2"
128 if [ "$?" = 0 -a "$eval_ret" = 0 ]
138 case "$test_failure" in
141 # cd .. && rm -fr trash
142 # but that means we forbid any tests that use their own
143 # subdirectory from calling test_done without coming back
144 # to where they started from.
145 # The Makefile provided will clean this test area so
146 # we will leave things as they are.
148 say "passed all $test_count test(s)"
152 say "failed $test_failure among $test_count test(s)"
158 # Test the binaries we have just built. The tests are kept in
159 # t/ subdirectory and are run in trash subdirectory.
161 GIT_EXEC_PATH=$(pwd)/..
169 git-init-db --template=../../templates/blt/ 2>/dev/null ||
170 error "cannot run git-init-db"
172 mv .git/hooks .git/hooks-disabled